program aratime;

uses dos,crt,ddplusa,misc,filelock;

type player_info = record
   name: string[20]; {player handle in the game}
   real_name: string[50] {real name/or handle from BBS} ;
   hit_points  {player hit points}
  ,bad  {don't know - might not be used at all}
  ,rate: integer; {again, couldn't find this one in the source}
  hit_max: integer; {hit_point max}
  weapon_num: integer; {weapon number}
  weapon: string[20]; {name of weapon}
  seen_master: integer; {equals 5 if seen master, else 0}
  fights_left: integer; {forest fights left}
  human_left: integer; {human fights left}
  gold: longint; {gold in hand}
  bank: longint; {gold in bank}
  def: integer;  {total defense points }
  strength: integer; {total strength}
  charm: integer; {good looking meter}
  seen_dragon: integer; {seen dragon?  5 if yes else 0}
  seen_violet: integer; {seen violet?  5 if yes else 0}
  level: integer; {level of player}
  time: word; {day # that player last played on}
  arm: string[20]; {armour name}
  arm_num: integer; {armour number}
  dead: shortint; {player dead?  5 if yes else 0}
  inn: shortint; {player sleeping at inn?  5 if yes else 0}
  gem: integer; {# of gems on hand}
  exp: longint; {experience}
  sex: shortint; {gender, 5 if female else 0}
  seen_bard: shortint; {seen bard?  5 if yes else 0}
  last_alive_time: integer; {day # player was last reincarnated on}
  Lays: integer; {players lays stat}
  Why: integer; {not used yet}
  on_now: boolean; {is player on?}
  m_time: integer; {day on_now stat was last used}
  time_on: string[5]; {time player logged on in Hour:Minutes format}
  class: shortint; {class, should be 1, 2 or 3}
  extra: integer;      {*NEW*  If 1, player has a horse}
  love: string[25]; {not used - may be used for inter-player marrages later}
  married: integer; {who player is married to, should be -1 if not married}
  kids: integer; {# of kids}
  king: integer; {# of times player has won game}
  skillw: shortint; {number of Death Knight skill points}
  skillm: shortint; {number of Mystical Skills points}
  skillt: shortint; {number of Thieving Skills points}

  levelw: shortint; {number of Death Knight skill uses left today}
  levelm: shortint; {number of Mystical skill uses left today}
  levelt: shortint; {number of Thieving skill uses left today}

  inn_random: boolean; {not used yet}
  married_to: integer; {same as Married, I think - don't know why it's here}
  v1: longint;
  v2: integer; {# of player kills}
  v3: integer; {if 5, 'wierd' event in forest will happen}
  v4: boolean; {has player done 'special' for that day?}
  v5: shortint; {has player flirted with another player that day?  if so, 5}
  new_stat1: shortint;
  new_stat2: shortint;  {these 3 are unused right now}
  new_stat3: shortint;  {Warning: Joseph's NPCLORD screws with all three}

end;

re_info = array[0..149] of boolean;
rec_rec = record
            path:string;
            ri:re_info;
          end;

var pf:file of player_info;
    pr:player_info;
    tf:file of rec_rec;
    tr:rec_rec;
    tlpath,tempstr:string;
    mynum,errcode:integer;
    tempnum:longint;
    elbow:array[1..14] of string[30];
    cashbet:extended;
    times:integer;
    data:text;
    saveexit:pointer;

function caps(s:string):string;
 var c:byte;
  begin
    for c := 1 to length(s) do s[c] := UPCASE(s[c]);
    caps := s;
  end;

procedure lwriteln(s:string);
 label DEVIL;
 var f,g,h: string;
     done:boolean;
     q:byte;
  begin
    done := false;
    IF NOT POS('`',s) > 0 then begin
      writeln(s);
      exit;
    end;
   repeat
    IF s[pos('`',s)+1] IN ['0','1','2','3','4','5','6','7','8','9','!','@','#','$','%'] then begin
       g := '';
       for q := 1 to POS('`',s)-1 do g := g + s[q];
       write(g);
       CASE s[POS('`',s)+1] of
       '1':textcolor(1);
       '2':textcolor(2);
       '3':textcolor(3);
       '4':textcolor(4);
       '5':textcolor(5);
       '6':textcolor(6);
       '7':textcolor(7);
       '8':textcolor(8);
       '9':textcolor(9);
       '0':textcolor(10);
       '!':textcolor(11);
       '@':textcolor(12);
       '#':textcolor(13);
       '$':textcolor(14);
       '%':textcolor(15);
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       s := f;
       end;
   until POS('`',s) = 0;
   writeln(s);
  end;


procedure lwrite(s:string);
 label DEVIL;
 var f,g,h: string;
     done:boolean;
     q:byte;
  begin
    done := false;
    IF NOT POS('`',s) > 0 then begin
      writeln(s);
      exit;
    end;
   repeat
    IF s[pos('`',s)+1] IN ['0','1','2','3','4','5','6','7','8','9','!','@','#','$','%'] then begin
       g := '';
       for q := 1 to POS('`',s)-1 do g := g + s[q];
       write(g);
       CASE s[POS('`',s)+1] of
       '1':textcolor(1);
       '2':textcolor(2);
       '3':textcolor(3);
       '4':textcolor(4);
       '5':textcolor(5);
       '6':textcolor(6);
       '7':textcolor(7);
       '8':textcolor(8);
       '9':textcolor(9);
       '0':textcolor(10);
       '!':textcolor(11);
       '@':textcolor(12);
       '#':textcolor(13);
       '$':textcolor(14);
       '%':textcolor(15);
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       s := f;
       end;
   until POS('`',s) = 0;
   write(s);
  end;



procedure fwriteln(s:string);
 label DEVIL;
 var f,g,h: string;
     done:boolean;
     q:byte;
  begin
    done := false;
   repeat
    IF pos('`',s) > 0 then begin { IN ['0','1','2','3','4','5','6','7','8','9','!','@','#','$','%'] then begin}
       g := '';
       for q := 1 to POS('`',s)-1 do g := g + s[q];
       swrite(g);
       CASE s[POS('`',s)+1] of
       '1':set_foreground(1);
       '2':set_foreground(2);
       '3':set_foreground(3);
       '4':set_foreground(4);
       '5':set_foreground(5);
       '6':set_foreground(6);
       '7':set_foreground(7);
       '8':set_foreground(8);
       '9':set_foreground(9);
       '0':set_foreground(10);
       '!':set_foreground(11);
       '@':set_foreground(12);
       '#':set_foreground(13);
       '$':set_foreground(14);
       '%':set_foreground(15);
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       s := f;
       end;
   until POS('`',s) = 0;
   swriteln(s);
  end;






function stripped(s:string):string;
  var ti:byte;
  f,g:string;
  begin
    WHILE POS('`',s) > 0 do begin
      f := '';
      g := '';
      for ti := 1 to POS('`',s)-1 do f := f+s[ti];
      for ti := POS('`',s)+2 to length(s) do g := g + s[ti];
      s := f+g;
    end;
    stripped :=s;
  end;

procedure fwrite(s:string);
 label DEVIL;
 var f,g,h: string;
     done:boolean;
     q:byte;
  begin
    done := false;
    IF NOT POS('`',s) > 0 then begin
      swrite(s);
      exit;
    end;
   repeat
    IF pos('`',s)>0 then begin{IN ['0','1','2','3','4','5','6','7','8','9','!','@','#','$','%'] then begin}
       g := '';
       for q := 1 to POS('`',s)-1 do g := g + s[q];
       swrite(g);
       CASE s[POS('`',s)+1] of
       '1':set_foreground(1);
       '2':set_foreground(2);
       '3':set_foreground(3);
       '4':set_foreground(4);
       '5':set_foreground(5);
       '6':set_foreground(6);
       '7':set_foreground(7);
       '8':set_foreground(8);
       '9':set_foreground(9);
       '0':set_foreground(10);
       '!':set_foreground(11);
       '@':set_foreground(12);
       '#':set_foreground(13);
       '$':set_foreground(14);
       '%':set_foreground(15);
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       s := f;
       end;
   until POS('`',s) = 0;
   swrite(s);
  end;



procedure moreprompt;
  var ch:char;
  begin
    fwrite('`0<`2MORE`0>');
    sread_char(ch);
  end;
function center(s:string;l:byte):string;
 var tempstr:string;
     n:byte;
  begin
    tempstr := '';
    for n := 1 to ((l-(LENGTH(stripped(s)))) DIV 2) do tempstr := tempstr + ' ';
    center := tempstr+s;
  end;

function fileexists(FNAME:string):boolean;
  var tfile:text;
      s: string;
  begin
    s := FSEARCH(FNAME,'');
    fileexists := s <> '';
  end;



procedure uninstallnet;
  var data:text;
    t: array[1..30] of string;
    r: byte;
    s,f: byte;
  begin

    assign(data,tempstr+'3rdparty.dat');
    reset(data);
    s:=0;r:=0;f:=0;
    repeat
      inc(f);
      readln(data,t[f]);
      IF POS('ARATIME',t[f]) > 0 then s := f;
    until eof(data);
    close(data);
    IF s = 0 then begin
      writeln('Aragorn''s Timer has not been installed yet!');
      halt;
    end;
    assign(data,tempstr+'3rdparty.dat');
    rewrite(data);
    for r := 1 to f do begin
      IF NOT (r = s) and not (r = s+1) then writeln(data,t[r]);
    end;
    close(data);
    IF FILEEXISTS(tlpath+'\aratime.dat') then begin
      assign(data,tlpath+'\aratime.dat');
      erase(data);
    end;
    lwriteln('`%Uninstalled!');
    lwriteln('`2<`0MORE`2>');
    readkey;
  end;



function installnet:boolean;
 var data:text;
     t:array[1..30] of string;
     r,s,e:byte;
     tempst : string;
  begin
{    r := 0;
    s := 0;
    assign(data,TEMPSTR+'3rdparty.dat');
    reset(data);
    repeat
      inc(s);
      readln(data,t[s]);
      IF POS('ARATIME',t[s]) > 0 then begin
        installnet := true;
        close(data);
        exit;
      end;
      IF NOT (t[s][1] = ';') then inc(r);
    until eof(data);
    close(data);}
{    IF R > 16 then begin
      clrscr;
      writeln('You currently have too many Lord Utils installed!');
      writeln;
      writeln('Please remove one (from the 3RDPARTY.DAT file in the LORD directory).');
      halt(0);
    end;}
    assign(data,tempstr+'3rdparty.dat');
    tempst := '';
    {hymn := paramstr(0);
    for e := 1 to length(hymn)-11 do tempst := tempst + hymn[e];}
    append(data);
    writeln(data,tlpath+'\ARATIME *');
    writeln(data,'`%Aragorn`2''s Timer');
    close(data);
    writeln;
    lwriteln('`%Installed!');
    writeln;
    lwriteln('`2<`0MORE`2>');
    readkey;
    tr.path := tempstr;
    for r := 0 to 149 do tr.ri[r] := false;
    get_access_hard(tlpath+'\aratime.dat',false);
    assign(tf,tlpath+'\aratime.dat');
    rewrite(tf);
    write(tf,tr);
    close(tf);
    unlock_file(tlpath+'\aratime.dat');
  end;


procedure configuration;
  label hiya;
  var ch:char;
  begin
    clrscr;
    lwriteln('                    `%Ara Time Setup!');
    writeln;
    tempstr := '';
    hiya:
    IF FILEEXISTS(tlpath+'\aratime.dat') then begin
      get_access_hard(tlpath+'\aratime.dat',true);
      assign(tf,tlpath+'\aratime.dat');
      reset(tf);
      read(tf,tr);
      close(tf);
      unlock_file(tlpath+'\aratime.dat');
      tempstr := tr.path;
    end;
    IF (TEMPSTR = '') then begin;
    writeln;
    lwrite('  `2Please enter your LORD path `0(`$C:\LORD\`0)`!:`% ');
    readln(tempstr);
    IF (TEMPSTR = '') then tempstr := 'C:\lord\';
    writeln;
    lwrite('`2Path is...');
    IF (tempstr[length(tempstr)] <> '\') then tempstr := tempstr + '\';
    IF fileexists(tempstr+'3rdparty.dat')
    then lwriteln('`0VERIFIED!') else begin
      lwriteln('`4INVALID');
      goto hiya;
    end;
    end;
    IF (installnet) then begin
      repeat
        clrscr;
        lwriteln('`0(`2U`0)`2ninstall AraTime');
        lwriteln('`0(`2Q`0)`2uit CONFIG');
        ch := readkey;
        IF (UPCASE(CH) = 'Q') then halt(0);
        IF (UPCASE(CH) = 'U') then uninstallnet;
      until (CH = '');
      halt(0);
    end;
  halt(0);
  end;




{$F+} procedure myexit1; {$F-}
begin
  get_access_hard(tlpath+'\aratime.dat',false);
  getdir(0,tr.path);
  tr.path := tr.path +'\';
  assign(tf,tlpath+'\aratime.dat'); {This is the exit procedure - it always runs!}
  rewrite(tf);
  write(tf,tr);
  close(tf);
  unlock_file(tlpath+'\aratime.dat');
  get_access_hard('player.dat',true);
  assign(pf,'player.dat');
  reset(pf);
  seek(pf,mynum);
  write(pf,pr);
  close(pf);
  unlock_file('player.dat');
  trapexit; {From MISC.PAS}
end;


procedure menu;
  var ch:char;
  done:boolean;
  h,m,s,s1:array[1..2] of word;
  tm,ts:word;
  realnum:integer;
  begin
    sclrscr;
    fwriteln('`2You take a hesitant step toward the opening of `0Aragorn`2''s Cave.');
    fwriteln('You''ve heard of his games making some very rich indeed, and you');
    fwriteln('desire that wealth.  But others have been broken - destined to be');
    fwriteln('level five warriors forever...');
    swriteln('');
    fwrite('`2Shall you enter? [`5N`2]:`% ');
    sread_char(ch);
    IF (UPCASE(CH) <> 'Y') then ch := 'N';
    swriteln(UPCASE(CH));
    IF (UPCASE(CH) = 'N') then begin
      swriteln('');
      fwriteln('`2You turn, and run back to the realm.');
      moreprompt;
      halt(0);
    end;
      sclrscr;
      fwriteln('`0Aragorn `2smiles, to welcome you.  Many piles of gold are stacked');
      fwriteln('by his side.  The dingy room radiates a rare type of warmth, and ');
      fwriteln('you are compelled to sit down in the chair opposite him.');
      swriteln('');
      IF (PR.SEx = 5) then tempstr := 'daughter' else tempstr := 'son';
      fwriteln('`%"`0My '+tempstr+', I play a very simple game.  You have 20');
      fwriteln('seconds and 15 tries to guess my number, from 1 to 1000.  If');
      fwriteln('you get it right, then I will give you your money, and half');
      fwriteln('again.  If you do not, then you lose all.');
      swriteln('');
      IF (PR.GOLD < 1) then begin
        fwriteln('`0Aragorn `2suddenly stands up.');
        fwriteln('`%"`0You have no money!  Why don''t you get some, and come back later!');
        moreprompt;
        halt(0);
      end;
      fwriteln('`%"`0Good.  Now, do you wish to play?`%"');
      swriteln('');
      fwrite('`2[`5Y`2]:`% ');
      sread_char(ch);
      IF (UPCASE(CH) <> 'N') then ch := 'Y';
      swriteln(UPCASE(CH));
      IF (UPCASE(CH) = 'N') then begin
        swriteln('');
        fwriteln('`0Aragorn `2dismisses you with a wave of his hand.');
        moreprompt;
        halt(0);
      end;
      tr.ri[mynum] := true;
      sclrscr;
      repeat
        str(pr.gold,tempstr);
        fwrite('`2How much of your `$'+tempstr+' `2will you wager?`% ');
        sread(tempstr);
        val(tempstr,tempnum,errcode);
      until (tempnum > 0) and (errcode = 0) and (tempnum <= pr.gold);
      cashbet := tempnum;
      swriteln('');
      fwriteln('`0Aragon `2smiles.  He turns over his timeglass.');
      swriteln('');
      randomize;
      realnum := 1+random(1000);
      fwrite('`2Guess?`% ');
      sread(tempstr);
      gettime(h[1],m[1],s[1],s1[1]);
      ts := s[1]+20;
      tm := m[1]+1;
      IF (ts > 59) then begin
        dec(ts,60);
        inc(tm);
      end;
      done := false;
      IF (TM > 59) then dec(tm, 60);
      val(tempstr,tempnum,errcode);
        IF (TEMPNUM > realnum) then tempstr := 'Too High'
        else if (tempnum < realnum) then tempstr := 'Too Low';
        IF NOT done and (tempnum <> realnum) THEN BEGIN
          gettime(h[2],m[2],s[2],s1[2]);
          fwriteln('`0'+tempstr);
          IF ((TS-s[2]) > 20) then str(60+(ts-s[2]),tempstr) else
          str(ts-s[2],tempstr);
          fwriteln('`2You have `$'+tempstr+' `2seconds left!');
          swriteln('');
          end;
      done := false;
      times := 1;
      while (tempnum <> realnum) and not done do begin
        fwrite('`2Guess?`% ');
        sread(tempstr);
        val(tempstr,tempnum,errcode);
        gettime(h[2],m[2],s[2],s1[2]);
        IF (s[2] >= ts) or (m[2] >= tm) then done := true;
        inc(times);
        IF (Times > 15) then done := true;
        IF NOT DONE THEN
        IF (TEMPNUM > realnum) then tempstr := 'Too High'
        else if (tempnum < realnum) then tempstr := 'Too Low';
        IF DONE AND (tempnum = realnum) then done := false;
        IF NOT done and (tempnum <> realnum) THEN BEGIN
          fwriteln('`0'+tempstr);
          IF ((TS-s[2]) > 20) then str(60+(ts-s[2]),tempstr) else
          str(ts-s[2],tempstr);
          fwriteln('`2You have `$'+tempstr+' `2seconds left!');
          swriteln('');
        end;
      end;
      IF DONE then begin
        swriteln('');
IF (times < 16) then        fwriteln('`2Time''s Up!')
else fwriteln('`2Guess Limit Exceeded!');

        swriteln('');
        str(cashbet:0:0,tempstr);
        fwriteln('`0Aragorn `2smiles softly to himself, and deposits your `$'+tempstr);
        fwriteln('`2into his pocket.  He then sits down, and waves you away.');
        swriteln('');
        fwriteln('`2You trudge out of the cave, very disappointed.  Maybe tomorrow.');
        dec(pr.gold,round(cashbet));
        moreprompt;
        halt(0);
      end;
      swriteln('');
      fwriteln('`0Aragorn `2looks extremely surprised.  You try to hide the smug look');
      fwriteln('on your face.');
      swriteln('');

      cashbet := cashbet / 2;
      str(cashbet:0:0,tempstr);
      inc(pr.gold,round(cashbet));
      fwriteln('`%"`0So you beat me once... Beginner''s luck.  Anyway, I do play fair,');
      fwriteln(' so here is the `$'+tempstr+' `0gold I owe you.');
      swriteln('');
      fwriteln('`2You think that this would be a good time to depart, before `0Aragon');
      fwriteln('`2grabs his money back.  You skip home, delighted!');
      moreprompt;
      halt(0);
    end;





procedure chkmaint;
var datetest2,datetest,nom,bbs,path:string[80];
    year,month,day,dow:word;

  begin
    IF NOT FileExists('aragtime.dat') then begin
    assign(data,'aragtime.dat');
    rewrite(data);
    GetDate(year,month,day,dow);
    str(year+month+day-1,datetest);
    writeln(data, datetest);
    close(data);
  end;
  assign(data,'aragtime.dat');
  reset(data);
  readln(data,datetest);
  close(data);
  getdate(year,month,day,dow);
  str(year+month+day,datetest2);
  IF (datetest = datetest2) then begin
    exit;
  end;
  assign(data,'aragtime.dat');
  rewrite(data);
  GetDate(year,month,day,dow);
  writeln(data, year+month+day);
  close(data);
  getdir(0,tr.path);
  tr.path := tr.path +'\';
  get_access_hard(tlpath+'\aratime.dat',false);
  assign(tf,tlpath+'\aratime.dat');
  rewrite(tf);
  for tempnum := 0 to 149 do tr.ri[tempnum] := false;
  write(tf,tr);
  close(tf);
  unlock_file(tlpath+'\aratime.dat');
end;



procedure chkme;
  begin
    IF FILEEXISTS(tlpath+'\aratime.dat') then begin
    get_access_hard(tlpath+'\aratime.dat',true);
    assign(tf,tlpath+'\aratime.dat');
    reset(tf);
    read(tf,tr);
    close(tf);
    unlock_file(tlpath+'\aratime.dat');
    IF (TR.ri[mynum] = true) then begin
      sclrscr;
      fwriteln('`0Aragorn`2''s Cave looks darker than it usually does.');
      fwriteln('`2Maybe he''s not home...');
      moreprompt;
      halt(0);
    end;
    end
    else for tempnum := 0 to 149 do tr.ri[tempnum] := false;
  end;


begin
  IF (PARAMSTR(0) = '') then begin
    lwriteln('`2Aragorn''s Timer!');
    writeln;
    lwriteln('`%You must run this with the CONFIG parameter to configure.');
    lwriteln('Otherwise just run it through LORD.');
    delay(1000);
    halt;
  end;
  tlpath:='';
  tempstr := paramstr(0);
  for tempnum := 1 to Length(tempstr)-12 do tlpath := tlpath + tempstr[tempnum];
  IF caps(PARAMSTR(1)) = 'CONFIG' then configuration;
  initdoordriver('node'+paramstr(1)+'.dat');
  assign(data,'info.'+paramstr(1));
  reset(data);
  for tempnum := 1 to 14 do if not eof(data) then readln(data,elbow[tempnum]);
  close(data);
  val(paramstr(1),node_num,errcode);
  statfore := 14;
  statback := 1;
  notime := '**** TIMEOUT ****';
  progname := 'Aragorn''s Timer';
  user_first_name := stripped(elbow[6]);
  ansion := true;
  SaveExit:=Exitproc;
  ExitProc:=@myexit1;
  val(elbow[1],mynum,errcode);
  get_access_hard('player.dat',true);
  assign(pf,'player.dat');
  reset(pf);
  seek(pf,mynum); {Use this instead of incessant read() commands!}
  read(pf,pr);
  close(pf);
  unlock_file('player.dat');
  chkmaint;
  chkme;
  menu;
end.

